#include <iostream>
#include <string>
#include "Person.h"

using namespace std;

// constructor overloading
Person::Person(string name, uint8_t age) {
  aliases = new vector<string>{};
    this->name = name;
    this->age = age;
    aliases->push_back(name);
}

// copy constructor
Person::Person(const Person& person) {
  aliases = new vector<string>(*person.aliases);
  name = person.getName();
  age = person.getAge();
  cout << "called copy constructor\n";
}

// question: why this return type?
Person& Person::operator=(const Person& that) {
  // question: why do we do this check?
  if (this == &that) {
    return *this;
  }

  delete aliases;

  aliases = new vector<string>(* that.aliases);
  name = that.name;
  age = that.age;

  return *this;
}

const string& Person::getName() const { return name; }

uint8_t Person::getAge() const { return age; }

const vector<string>& Person::getAliases() const {
  return *aliases;
}

void Person::setName(string name) {
  aliases->push_back(name);
  this->name = name;
}

void Person::setAge(uint8_t age) {
  this->age = age;
}
